from coalib.bearlib.abstractions.Linter import linter
from dependency_management.requirements.PipRequirement import PipRequirement


@linter(executable='pyannotate',
        output_format='unified-diff')
class PyAnnotateBear:  # pragma: no cover
    """
    Auto-generates PEP-484 annotations into the source code.

    Annotations use arguments and return types observed at runtime using
    ``pyannotate``.

    See https://github.com/dropbox/pyannotate for more info.
    """

    LANGUAGES = {'Python', 'Python 2', 'Python 3'}
    REQUIREMENTS = {PipRequirement('pyannotate', '1.0.6')}
    CAN_DETECT = {'Documentation'}
    CAN_FIX = {'Commented Code'}

    @staticmethod
    def create_arguments(filename, file, config_file):
        """
        Return executable arguments.

        The bear uses the output diff generated by 'pyannotate' given the
        argument and return type dump at '.pyannotate_type_info'.
        """
        return (filename, '--type-info', '.pyannotate_type_info')
